structure L0Theory :> L0Theory =
struct
  open Type Term Thm
  infixr -->
  fun C s t ty = mk_thy_const{Name=s,Thy=t,Ty=ty}
  fun T s t A = mk_thy_type{Tyop=s, Thy=t,Args=A}
  fun V s q = mk_var(s,q)
  val U     = mk_vartype
  
  (*  Parents *)
  local open integerTheory stringTheory
  in end;
  val _ = Theory.link_parents
          ("L0",51329319,0)
          [("string",44414669,0), ("integer",44414776,0)];
  val _ = Theory.incorporate_types "L0"
       [("PROG",1), ("INSTR",0), ("void",0), ("PBODY",1), ("REF",1)];
  val _ = Theory.incorporate_consts "L0"
     [("void2num",((T"void" "L0" [] --> T"num" "num" []))),
      ("void",(T"void" "L0" [])),
      ("wloop",((bool --> (T"INSTR" "L0" [] --> T"INSTR" "L0" [])))),
      ("REF",((alpha --> T"REF" "L0" [alpha]))), ("skip",(alpha)),
      ("L00",((alpha --> T"REF" "L0" [alpha]))),
      ("REF_case",(((alpha --> beta) --> (T"REF" "L0" [alpha] --> beta)))),
      ("void_size",((T"void" "L0" [] --> T"num" "num" []))),
      ("none",(T"void" "L0" [])),
      ("/@=",
       ((U"'retval" -->
         (T"PROG" "L0" [U"'retval"] --> T"INSTR" "L0" [])))),
      ("/:=",((alpha --> (alpha --> T"INSTR" "L0" [])))),
      ("progdef_rhs",
       ((bool -->
         (bool -->
          (T"PBODY" "L0" [U"'retval"] --> T"PROG" "L0" [U"'retval"]))))),
      ("num2void",((T"num" "num" [] --> T"void" "L0" []))),
      ("mk_REF",
       ((T"recspace" "ind_type" [alpha] --> T"REF" "L0" [alpha]))),
      ("REF_size",
       (((alpha --> T"num" "num" []) -->
         (T"REF" "L0" [alpha] --> T"num" "num" [])))),
      ("return",
       ((T"INSTR" "L0" [] -->
         (U"'retval" --> T"PBODY" "L0" [U"'retval"])))),
      ("dest_REF",
       ((T"REF" "L0" [alpha] --> T"recspace" "ind_type" [alpha]))),
      ("assert",((bool --> T"INSTR" "L0" []))),
      ("seq",((alpha --> (alpha --> alpha)))), ("ret",(alpha)),
      ("old",((alpha --> alpha))),
      ("/@",
       (((U"'params" --> T"PROG" "L0" [U"'retval"]) -->
         (U"'params" --> T"INSTR" "L0" [])))),
      ("printStr",((T"string" "string" [] --> T"INSTR" "L0" []))),
      ("void_case",((alpha --> (alpha --> (T"void" "L0" [] --> alpha))))),
      ("printInt",((T"int" "integer" [] --> T"INSTR" "L0" [])))];
  
  local
  val share_table = Vector.fromList
  [C"?" "bool"
    ((((T"void" "L0" [] --> T"num" "num" []) --> bool) --> bool)),
   V"rep" ((T"void" "L0" [] --> T"num" "num" [])),
   C"TYPE_DEFINITION" "bool"
    (((T"num" "num" [] --> bool) -->
      ((T"void" "L0" [] --> T"num" "num" []) --> bool))),
   V"n" (T"num" "num" []),
   C"<" "prim_rec" ((T"num" "num" [] --> (T"num" "num" [] --> bool))),
   C"NUMERAL" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"NUMERAL_BIT2" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"ALT_ZERO" "arithmetic" (T"num" "num" []),
   C"/\\" "bool" ((bool --> (bool --> bool))),
   C"!" "bool" (((T"void" "L0" [] --> bool) --> bool)),
   V"a" (T"void" "L0" []),
   C"=" "min" ((T"void" "L0" [] --> (T"void" "L0" [] --> bool))),
   C"num2void" "L0" ((T"num" "num" [] --> T"void" "L0" [])),
   C"void2num" "L0" ((T"void" "L0" [] --> T"num" "num" [])),
   C"!" "bool" (((T"num" "num" [] --> bool) --> bool)),
   V"r" (T"num" "num" []), C"=" "min" ((bool --> (bool --> bool))),
   C"=" "min" ((T"num" "num" [] --> (T"num" "num" [] --> bool))),
   C"void" "L0" (T"void" "L0" []), C"0" "num" (T"num" "num" []),
   C"none" "L0" (T"void" "L0" []),
   C"NUMERAL_BIT1" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   V"x" (T"void" "L0" []),
   C"void_size" "L0" ((T"void" "L0" [] --> T"num" "num" [])),
   C"!" "bool" (((alpha --> bool) --> bool)), V"x0" (alpha), V"x1" (alpha),
   C"=" "min" ((alpha --> (alpha --> bool))),
   C"void_case" "L0" ((alpha --> (alpha --> (T"void" "L0" [] --> alpha)))),
   C"?" "bool"
    ((((T"REF" "L0" [alpha] --> T"recspace" "ind_type" [alpha]) --> bool)
      --> bool)),
   V"rep" ((T"REF" "L0" [alpha] --> T"recspace" "ind_type" [alpha])),
   C"TYPE_DEFINITION" "bool"
    (((T"recspace" "ind_type" [alpha] --> bool) -->
      ((T"REF" "L0" [alpha] --> T"recspace" "ind_type" [alpha]) -->
       bool))), V"a0" (T"recspace" "ind_type" [alpha]),
   C"!" "bool"
    ((((T"recspace" "ind_type" [alpha] --> bool) --> bool) --> bool)),
   V"'REF'" ((T"recspace" "ind_type" [alpha] --> bool)),
   C"==>" "min" ((bool --> (bool --> bool))),
   C"!" "bool" (((T"recspace" "ind_type" [alpha] --> bool) --> bool)),
   C"?" "bool" (((alpha --> bool) --> bool)), V"a" (alpha),
   C"=" "min"
    ((T"recspace" "ind_type" [alpha] -->
      (T"recspace" "ind_type" [alpha] --> bool))),
   C"CONSTR" "ind_type"
    ((T"num" "num" [] -->
      (alpha -->
       ((T"num" "num" [] --> T"recspace" "ind_type" [alpha]) -->
        T"recspace" "ind_type" [alpha])))),
   C"BOTTOM" "ind_type" (T"recspace" "ind_type" [alpha]),
   C"!" "bool" (((T"REF" "L0" [alpha] --> bool) --> bool)),
   V"a" (T"REF" "L0" [alpha]),
   C"=" "min" ((T"REF" "L0" [alpha] --> (T"REF" "L0" [alpha] --> bool))),
   C"mk_REF" "L0"
    ((T"recspace" "ind_type" [alpha] --> T"REF" "L0" [alpha])),
   C"dest_REF" "L0"
    ((T"REF" "L0" [alpha] --> T"recspace" "ind_type" [alpha])),
   V"r" (T"recspace" "ind_type" [alpha]),
   C"=" "min"
    (((alpha --> T"REF" "L0" [alpha]) -->
      ((alpha --> T"REF" "L0" [alpha]) --> bool))),
   C"L00" "L0" ((alpha --> T"REF" "L0" [alpha])),
   C"REF" "L0" ((alpha --> T"REF" "L0" [alpha])),
   C"!" "bool" ((((alpha --> beta) --> bool) --> bool)),
   V"f" ((alpha --> beta)), C"=" "min" ((beta --> (beta --> bool))),
   C"REF_case" "L0"
    (((alpha --> beta) --> (T"REF" "L0" [alpha] --> beta))),
   C"!" "bool" ((((alpha --> T"num" "num" []) --> bool) --> bool)),
   V"f" ((alpha --> T"num" "num" [])),
   C"REF_size" "L0"
    (((alpha --> T"num" "num" []) -->
      (T"REF" "L0" [alpha] --> T"num" "num" []))),
   C"+" "arithmetic"
    ((T"num" "num" [] --> (T"num" "num" [] --> T"num" "num" []))),
   V"r'" (T"num" "num" []), V"a'" (T"void" "L0" []),
   C"?" "bool" (((T"num" "num" [] --> bool) --> bool)),
   C"?" "bool" (((T"void" "L0" [] --> bool) --> bool)),
   C"~" "bool" ((bool --> bool)), V"M" (T"void" "L0" []),
   V"M'" (T"void" "L0" []), V"x0'" (alpha), V"x1'" (alpha),
   C"\\/" "bool" ((bool --> (bool --> bool))),
   C"?" "bool" ((((T"void" "L0" [] --> alpha) --> bool) --> bool)),
   V"f" ((T"void" "L0" [] --> alpha)),
   C"!" "bool" ((((T"void" "L0" [] --> bool) --> bool) --> bool)),
   V"P" ((T"void" "L0" [] --> bool)), V"a'" (alpha),
   V"M" (T"REF" "L0" [alpha]), V"M'" (T"REF" "L0" [alpha]),
   V"f'" ((alpha --> beta)), V"R" (T"REF" "L0" [alpha]),
   C"?" "bool" ((((T"REF" "L0" [alpha] --> beta) --> bool) --> bool)),
   V"fn" ((T"REF" "L0" [alpha] --> beta)),
   C"!" "bool" ((((T"REF" "L0" [alpha] --> bool) --> bool) --> bool)),
   V"P" ((T"REF" "L0" [alpha] --> bool))]
  val DT = Thm.disk_thm share_table
  in
  val void_TY_DEF =
    DT("", [], `(%0 (\%1. ((%2 (\%3. ((%4 $0) (%5 (%6 %7))))) $0)))`)
  val void_BIJ =
    DT("", [],
       `((%8 (%9 (\%10. ((%11 (%12 (%13 $0))) $0)))) (%14 (\%15. ((%16
       ((\%3. ((%4 $0) (%5 (%6 %7)))) $0)) ((%17 (%13 (%12 $0))) $0)))))`)
  val void = DT("", [], `((%11 %18) (%12 %19))`)
  val none = DT("", [], `((%11 %20) (%12 (%5 (%21 %7))))`)
  val void_size_def = DT("", [], `(%9 (\%22. ((%17 (%23 $0)) %19)))`)
  val void_case_def =
    DT("", [],
       `((%8 (%24 (\%25. (%24 (\%26. ((%27 (((%28 $1) $0) %18)) $1))))))
       (%24 (\%25. (%24 (\%26. ((%27 (((%28 $1) $0) %20)) $0))))))`)
  val REF_TY_DEF =
    DT("", [],
       `(%29 (\%30. ((%31 (\%32. (%33 (\%34. ((%35 (%36 (\%32. ((%35 (%37
       (\%38. ((%39 $1) ((\%38. (((%40 %19) $0) (\%3. %41))) $0))))) ($1
       $0))))) ($0 $1)))))) $0)))`)
  val REF_repfns =
    DT("", [],
       `((%8 (%42 (\%43. ((%44 (%45 (%46 $0))) $0)))) (%36 (\%47. ((%16
       ((\%32. (%33 (\%34. ((%35 (%36 (\%32. ((%35 (%37 (\%38. ((%39 $1)
       ((\%38. (((%40 %19) $0) (\%3. %41))) $0))))) ($1 $0))))) ($0 $1)))))
       $0)) ((%39 (%46 (%45 $0))) $0)))))`)
  val L00_def =
    DT("", [],
       `((%48 %49) (\%38. (%45 ((\%38. (((%40 %19) $0) (\%3. %41)))
       $0))))`)
  val REF = DT("", [], `((%48 %50) %49)`)
  val REF_case_def =
    DT("", [],
       `(%51 (\%52. (%24 (\%38. ((%53 ((%54 $1) (%50 $0))) ($1 $0))))))`)
  val REF_size_def =
    DT("", [],
       `(%55 (\%56. (%24 (\%38. ((%17 ((%57 $1) (%50 $0))) ((%58 (%5 (%21
       %7))) ($1 $0)))))))`)
  val num2void_void2num =
    DT("", [], `(%9 (\%10. ((%11 (%12 (%13 $0))) $0)))`)
  val void2num_num2void =
    DT("", [],
       `(%14 (\%15. ((%16 ((%4 $0) (%5 (%6 %7)))) ((%17 (%13 (%12 $0)))
       $0))))`)
  val num2void_11 =
    DT("", [],
       `(%14 (\%15. (%14 (\%59. ((%35 ((%4 $1) (%5 (%6 %7)))) ((%35 ((%4
       $0) (%5 (%6 %7)))) ((%16 ((%11 (%12 $1)) (%12 $0))) ((%17 $1)
       $0))))))))`)
  val void2num_11 =
    DT("", [],
       `(%9 (\%10. (%9 (\%60. ((%16 ((%17 (%13 $1)) (%13 $0))) ((%11 $1)
       $0))))))`)
  val num2void_ONTO =
    DT("", [],
       `(%9 (\%10. (%61 (\%15. ((%8 ((%11 $1) (%12 $0))) ((%4 $0) (%5 (%6
       %7))))))))`)
  val void2num_ONTO =
    DT("", [],
       `(%14 (\%15. ((%16 ((%4 $0) (%5 (%6 %7)))) (%62 (\%10. ((%17 $1)
       (%13 $0)))))))`)
  val void_EQ_void =
    DT("", [],
       `(%9 (\%10. (%9 (\%60. ((%16 ((%11 $1) $0)) ((%17 (%13 $1)) (%13
       $0)))))))`)
  val void2num_void = DT("", [], `((%17 (%13 %18)) %19)`)
  val void2num_none = DT("", [], `((%17 (%13 %20)) (%5 (%21 %7)))`)
  val void_distinct = DT("", [], `(%63 ((%11 %18) %20))`)
  val void_case_cong =
    DT("", [],
       `(%9 (\%64. (%9 (\%65. (%24 (\%25. (%24 (\%26. ((%35 ((%8 ((%11 $3)
       $2)) ((%8 ((%35 ((%11 $2) %18)) ((%27 $1) %66))) ((%35 ((%11 $2)
       %20)) ((%27 $0) %67))))) ((%27 (((%28 $1) $0) $3)) (((%28 %66) %67)
       $2)))))))))))`)
  val void_nchotomy =
    DT("", [], `(%9 (\%10. ((%68 ((%11 $0) %18)) ((%11 $0) %20))))`)
  val void_Axiom =
    DT("", [],
       `(%24 (\%25. (%24 (\%26. (%69 (\%70. ((%8 ((%27 ($0 %18)) $2)) ((%27
       ($0 %20)) $1))))))))`)
  val void_induction =
    DT("", [],
       `(%71 (\%72. ((%35 ((%8 ($0 %20)) ($0 %18))) (%9 (\%10. ($1
       $0))))))`)
  val REF_11 =
    DT("", [],
       `(%24 (\%38. (%24 (\%73. ((%16 ((%44 (%50 $1)) (%50 $0))) ((%27 $1)
       $0))))))`)
  val REF_case_cong =
    DT("", [],
       `(%42 (\%74. (%42 (\%75. (%51 (\%52. ((%35 ((%8 ((%44 $2) $1)) (%24
       (\%38. ((%35 ((%44 $2) (%50 $0))) ((%53 ($1 $0)) (%76 $0)))))))
       ((%53 ((%54 $0) $2)) ((%54 %76) $1)))))))))`)
  val REF_nchotomy =
    DT("", [], `(%42 (\%77. (%37 (\%38. ((%44 $1) (%50 $0))))))`)
  val REF_Axiom =
    DT("", [],
       `(%51 (\%52. (%78 (\%79. (%24 (\%38. ((%53 ($1 (%50 $0))) ($2
       $0))))))))`)
  val REF_induction =
    DT("", [],
       `(%80 (\%81. ((%35 (%24 (\%38. ($1 (%50 $0))))) (%42 (\%77. ($1
       $0))))))`)
  end
  val _ = DB.bindl "L0"
  [("void_TY_DEF",void_TY_DEF,DB.Def), ("void_BIJ",void_BIJ,DB.Def),
   ("void",void,DB.Def), ("none",none,DB.Def),
   ("void_size_def",void_size_def,DB.Def),
   ("void_case_def",void_case_def,DB.Def),
   ("REF_TY_DEF",REF_TY_DEF,DB.Def), ("REF_repfns",REF_repfns,DB.Def),
   ("L00_def",L00_def,DB.Def), ("REF",REF,DB.Def),
   ("REF_case_def",REF_case_def,DB.Def),
   ("REF_size_def",REF_size_def,DB.Def),
   ("num2void_void2num",num2void_void2num,DB.Thm),
   ("void2num_num2void",void2num_num2void,DB.Thm),
   ("num2void_11",num2void_11,DB.Thm), ("void2num_11",void2num_11,DB.Thm),
   ("num2void_ONTO",num2void_ONTO,DB.Thm),
   ("void2num_ONTO",void2num_ONTO,DB.Thm),
   ("void_EQ_void",void_EQ_void,DB.Thm),
   ("void2num_void",void2num_void,DB.Thm),
   ("void2num_none",void2num_none,DB.Thm),
   ("void_distinct",void_distinct,DB.Thm),
   ("void_case_cong",void_case_cong,DB.Thm),
   ("void_nchotomy",void_nchotomy,DB.Thm),
   ("void_Axiom",void_Axiom,DB.Thm),
   ("void_induction",void_induction,DB.Thm), ("REF_11",REF_11,DB.Thm),
   ("REF_case_cong",REF_case_cong,DB.Thm),
   ("REF_nchotomy",REF_nchotomy,DB.Thm), ("REF_Axiom",REF_Axiom,DB.Thm),
   ("REF_induction",REF_induction,DB.Thm)]
  
  local open Portable GrammarSpecials Parse
  in
  val _ = mk_local_grms [("stringTheory.string_grammars",
                          stringTheory.string_grammars),
                         ("integerTheory.integer_grammars",
                          integerTheory.integer_grammars)]
  val _ = List.app (update_grms reveal) []
  val _ = update_grms temp_add_type "INSTR"
  val _ = update_grms temp_add_type "PROG"
  val _ = update_grms temp_add_type "PBODY"
  val _ = update_grms temp_add_type "void"
  val _ = update_grms
       (temp_overload_on_by_nametype "num2void")
        {Name = "num2void", Thy = "L0"}
  val _ = update_grms
       (temp_overload_on_by_nametype "void2num")
        {Name = "void2num", Thy = "L0"}
  val _ = update_grms
       (temp_overload_on_by_nametype "void")
        {Name = "void", Thy = "L0"}
  val _ = update_grms
       (temp_overload_on_by_nametype "none")
        {Name = "none", Thy = "L0"}
  val _ = update_grms
       (temp_overload_on_by_nametype "void_size")
        {Name = "void_size", Thy = "L0"}
  val _ = update_grms
       (temp_overload_on_by_nametype "void_case")
        {Name = "void_case", Thy = "L0"}
  val _ = update_grms
       (temp_overload_on_by_nametype "case")
        {Name = "void_case", Thy = "L0"}
  val _ = update_grms temp_add_type "REF"
  val _ = update_grms
       (temp_overload_on_by_nametype "mk_REF")
        {Name = "mk_REF", Thy = "L0"}
  val _ = update_grms
       (temp_overload_on_by_nametype "dest_REF")
        {Name = "dest_REF", Thy = "L0"}
  val _ = update_grms
       (temp_overload_on_by_nametype "L00")
        {Name = "L00", Thy = "L0"}
  val _ = update_grms
       (temp_overload_on_by_nametype "REF")
        {Name = "REF", Thy = "L0"}
  val _ = update_grms
       (temp_overload_on_by_nametype "REF_case")
        {Name = "REF_case", Thy = "L0"}
  val _ = update_grms
       (temp_overload_on_by_nametype "REF_size")
        {Name = "REF_size", Thy = "L0"}
  val _ = update_grms
       (temp_overload_on_by_nametype "case")
        {Name = "REF_case", Thy = "L0"}
  val _ = update_grms
       (temp_overload_on_by_nametype "printInt")
        {Name = "printInt", Thy = "L0"}
  val _ = update_grms
       (temp_overload_on_by_nametype "printStr")
        {Name = "printStr", Thy = "L0"}
  val _ = update_grms
       (temp_overload_on_by_nametype "print")
        {Name = "printInt", Thy = "L0"}
  val _ = update_grms
       (temp_overload_on_by_nametype "print")
        {Name = "printStr", Thy = "L0"}
  val _ = update_grms temp_add_infix ("/:=", 31, HOLgrammars.NONASSOC)
  val _ = update_grms
       (temp_overload_on_by_nametype "/:=")
        {Name = "/:=", Thy = "L0"}
  val _ = update_grms
       (temp_overload_on_by_nametype "skip")
        {Name = "skip", Thy = "L0"}
  val _ = update_grms
       (temp_overload_on_by_nametype "seq")
        {Name = "seq", Thy = "L0"}
  val _ = update_grms
       temp_add_listform
       {separator = ";", leftdelim = "/{", rightdelim = "/}", cons = "seq", nilstr = "skip"}
  val _ = update_grms
       (temp_overload_on_by_nametype "/@")
        {Name = "/@", Thy = "L0"}
  val _ = update_grms temp_add_infix ("/@=", 34, HOLgrammars.NONASSOC)
  val _ = update_grms
       (temp_overload_on_by_nametype "/@=")
        {Name = "/@=", Thy = "L0"}
  val _ = update_grms
       (temp_overload_on_by_nametype "wloop")
        {Name = "wloop", Thy = "L0"}
  val _ = update_grms
       temp_add_rule
       {term_name = "wloop", fixity = TruePrefix 19,
pp_elements = [PPBlock([TOK "while", BreakSpace(1, 0), TM, BreakSpace(1, 0), TOK "wdo", BreakSpace(1, 0)], (CONSISTENT, 3)), BeginFinalBlock (CONSISTENT, 0)],
paren_style = OnlyIfNecessary,
block_style = (AroundEachPhrase, (CONSISTENT, 0))}
  val _ = update_grms
       (temp_overload_on_by_nametype "assert")
        {Name = "assert", Thy = "L0"}
  val _ = update_grms temp_add_infix ("return", 29, HOLgrammars.NONASSOC)
  val _ = update_grms
       (temp_overload_on_by_nametype "return")
        {Name = "return", Thy = "L0"}
  val _ = update_grms
       (temp_overload_on_by_nametype "progdef_rhs")
        {Name = "progdef_rhs", Thy = "L0"}
  val _ = update_grms
       temp_add_rule
       {term_name = "progdef_rhs", fixity = TruePrefix 21,
pp_elements = [PPBlock([TOK "pre", HardSpace 1, TM, BreakSpace(1, 0), TOK "post", HardSpace 1, TM, BreakSpace(1, 0), TOK "do", HardSpace 1], (CONSISTENT, 0)), BeginFinalBlock (CONSISTENT, 3)],
paren_style = OnlyIfNecessary,
block_style = (AroundEachPhrase, (CONSISTENT, 0))}
  val _ = update_grms
       (temp_overload_on_by_nametype "ret")
        {Name = "ret", Thy = "L0"}
  val _ = update_grms
       (temp_overload_on_by_nametype "old")
        {Name = "old", Thy = "L0"}
  val L0_grammars = Parse.current_lgrms()
  end
  
  
  val _ =
     let open TypeBasePure 
         val tyinfo0 = mk_tyinfo
          {ax=ORIG void_Axiom,
           case_def=void_case_def,
           case_cong=void_case_cong,
           induction=ORIG void_induction,
           nchotomy=void_nchotomy,
           size=SOME(Parse.Term`(void_size) :void -> num`,
                     ORIG void_size_def),
           boolify = NONE,
  
           one_one=NONE,
           distinct=SOME void_distinct}
     in
      TypeBase.write  tyinfo0;
      computeLib.write_datatype_info tyinfo0
     end;
  
  
  val _ =
     let open TypeBasePure 
         val tyinfo0 = mk_tyinfo
          {ax=ORIG REF_Axiom,
           case_def=REF_case_def,
           case_cong=REF_case_cong,
           induction=ORIG REF_induction,
           nchotomy=REF_nchotomy,
           size=SOME(Parse.Term`(REF_size) :('a -> num) -> 'a REF -> num`,
                     ORIG REF_size_def),
           boolify = NONE,
  
           one_one=SOME REF_11,
           distinct=NONE}
     in
      TypeBase.write  tyinfo0;
      computeLib.write_datatype_info tyinfo0
     end;
  
end
