local

open Option Random 

in

fun int_rnd  rndgen = range (valOf Int.minInt div 2, valOf Int.maxInt div 2) rndgen
fun chr_rnd  rndgen = chr (range (0,127) rndgen)
fun bool_rnd rndgen = range (0,1) rndgen > 0
                     
fun list_rnd elem_rnd rndgen (* will only generate lists up-to length 10 *)
       =
       let
       val n = range (0,10) rndgen
       fun mk n = if n<=0 then []
                  else elem_rnd rndgen :: mk (n-1)
       in
       mk n
       end

val intlist_rnd  = list_rnd int_rnd
val boollist_rnd = list_rnd bool_rnd
val string_rnd   = String.implode o list_rnd chr_rnd

end