(* ===================================================================

  This provides XICOOPER_TAC, a small extension to COOPER which can 
  handle expression like p \/ 1>0.  

  author: wishnu prasetya

=================================================================== *)

local

open Parse HolKernel boolLib bossLib intLib xiTheory  ;

fun is_numrel t 
    = 
    mem (rator (rator t)) (map Term [`$>`, `$>=`, `$<`, `$<=`])
    handle 
    _ => false ;

fun is_inteq t
    =
    is_eq t andalso ((type_of o fst o dest_eq) t = Type `:int`)
    handle 
    _ => false ;

val ARG1_CONV    = RAND_CONV ;
val ARG2_CONV    = RATOR_CONV o RAND_CONV ;
fun ARG12_CONV c = ARG1_CONV c THENC ARG2_CONV c ;
val QUANTBODY_CONV = RAND_CONV o ABS_CONV ;

in

fun XI_CONV t =
    if is_forall t orelse is_exists t
       then QUANTBODY_CONV XI_CONV t
    else if is_disj t orelse is_conj t orelse is_imp_only t
       then ARG12_CONV XI_CONV t
    else if is_neg t
       then RAND_CONV XI_CONV t
    else if is_numrel t orelse is_inteq t
       then ALL_CONV t
    else REWR_CONV XI_lemma t
    ;

val XICOOPER_TAC = CONV_TAC (XI_CONV THENC COOPER_CONV) ;

end ;     
