signature linguTheory =
sig
  type thm = Thm.thm
  
  (*  Definitions  *)
    val ALLof_def : thm
    val SOMEof_def : thm
    val del_def : thm
    val deleteX_def : thm
    val delete_def : thm
    val drop_def : thm
    val ins_def : thm
    val insertX_def : thm
    val insert_def : thm
    val map_def : thm
    val only_def : thm
    val satisfy_def : thm
    val select_def : thm
    val updateX_def : thm
    val update_def : thm
  
  (*  Theorems  *)
    val ALLof_delete_thm : thm
    val ALLof_ins_thm : thm
    val ALLof_insert_thm : thm
    val ALLof_select_thm : thm
    val ALLof_update_thm : thm
    val IN_delete_thm : thm
    val IN_ins_thm : thm
    val IN_insert_thm : thm
    val IN_select_thm : thm
    val IN_update_thm : thm
    val SOMEof_delete_thm : thm
    val SOMEof_ins_thm : thm
    val SOMEof_insert_thm : thm
    val SOMEof_select_thm : thm
    val SOMEof_update_thm : thm
  
  val lingu_grammars : type_grammar.grammar * term_grammar.grammar
(*
   [L0] Parent theory of "lingu"
   
   [pred_set] Parent theory of "lingu"
   
   [ALLof_def]  Definition
      
      |- !t p. ALLof t p = !r. r IN t ==> p r
   
   [SOMEof_def]  Definition
      
      |- !t p. SOMEof t p = ?r. r IN t /\ p r
   
   [del_def]  Definition
      
      |- !r t. del r t = (t /:= deleteX t drop r'. r' = r)
   
   [deleteX_def]  Definition
      
      |- !t p. deleteX t p = {r | r IN t /\ ~p r}
   
   [delete_def]  Definition
      
      |- !t p. delete t p = (t /:= deleteX t p)
   
   [drop_def]  Definition
      
      |- !body. $drop body = body
   
   [ins_def]  Definition
      
      |- !r t. ins r t = (t /:= r INSERT t)
   
   [insertX_def]  Definition
      
      |- !td t f p. insertX td t f p = {f r | r IN td /\ p r} UNION t
   
   [insert_def]  Definition
      
      |- !td t f p. insert td t f p = (t /:= insertX td t f p)
   
   [map_def]  Definition
      
      |- !body. $map body = body
   
   [only_def]  Definition
      
      |- !body. $only body = body
   
   [satisfy_def]  Definition
      
      |- !body. $satisfy body = body
   
   [select_def]  Definition
      
      |- !t f p. select t f p = {f r | r IN t /\ p r}
   
   [updateX_def]  Definition
      
      |- !t f p. updateX t f p = {(if p r then f r else r) | r IN t}
   
   [update_def]  Definition
      
      |- !t f p. update t f p = (t /:= updateX t f p)
   
   [ALLof_delete_thm]  Theorem
      
      |- ALLof (deleteX t p) q = ALLof t (\r. ~p r ==> q r)
   
   [ALLof_ins_thm]  Theorem
      
      |- ALLof (r INSERT t) p = p r /\ ALLof t p
   
   [ALLof_insert_thm]  Theorem
      
      |- ALLof (insertX td t f p) q =
         ALLof td (\r. p r ==> q (f r)) /\ ALLof t q
   
   [ALLof_select_thm]  Theorem
      
      |- ALLof (select t f p) q = ALLof t (\r. p r ==> q (f r))
   
   [ALLof_update_thm]  Theorem
      
      |- ALLof (updateX t f p) q =
         ALLof t (\r. (p r ==> q (f r)) /\ (~p r ==> q r))
   
   [IN_delete_thm]  Theorem
      
      |- r IN deleteX t p = ~p r /\ r IN t
   
   [IN_ins_thm]  Theorem
      
      |- s IN r INSERT t = (s = r) \/ s IN t
   
   [IN_insert_thm]  Theorem
      
      |- r IN insertX td t f p =
         (?r'. p r' /\ r' IN td /\ (r = f r')) \/ r IN t
   
   [IN_select_thm]  Theorem
      
      |- r IN select t f p = ?r'. r' IN t /\ p r' /\ (r = f r')
   
   [IN_update_thm]  Theorem
      
      |- r IN updateX t f p =
         ?r'. r' IN t /\ (p r' ==> (r = f r')) /\ (~p r' ==> (r = r'))
   
   [SOMEof_delete_thm]  Theorem
      
      |- SOMEof (deleteX t p) q = SOMEof t (\r. ~p r /\ q r)
   
   [SOMEof_ins_thm]  Theorem
      
      |- SOMEof (r INSERT t) p = p r \/ SOMEof t p
   
   [SOMEof_insert_thm]  Theorem
      
      |- SOMEof (insertX td t f p) q =
         SOMEof td (\r. p r /\ q (f r)) \/ SOMEof t q
   
   [SOMEof_select_thm]  Theorem
      
      |- SOMEof (select t f p) q = SOMEof t (\r. p r /\ q (f r))
   
   [SOMEof_update_thm]  Theorem
      
      |- SOMEof (updateX t f p) q =
         SOMEof t (\r. p r /\ q (f r) \/ ~p r /\ q r)
   
   
*)
end
